class DuplicateError(Exception):
    """
    Exception raised to signal an asset already exists with the given identification.
    """

    def __init__(self, asset_identification):
        """
        Initialize the exception.

        :param asset_identification: The identification of the not found asset.
        """
        super().__init__("The asset already exists: {asset_identification}"
                         .format(asset_identification=asset_identification.to_dict()))

        self._asset_identification = asset_identification

    @property
    def asset_identification(self):
        return self._asset_identification
