class NotFoundError(Exception):
    """
    Exception raised to signal an asset was not found.
    """

    def __init__(self, asset_identification):
        """
        Initialize the exception.

        :param asset_identification: The identification of the not found asset.
        """
        super().__init__("The asset was not found: {asset_identification}"
                         .format(asset_identification=asset_identification.to_dict()))

        self._asset_identification = asset_identification

    @property
    def asset_identification(self):
        return self._asset_identification
