# coding: utf-8
"""
    Model for asset presence.
"""

import pprint


class AssetPresence:
    """
    Model for asset presence.
    """
    property_types = {
        'asset_presence': 'AssetPresenceStatus'
    }

    serialization_keys = {
        'asset_presence': 'assetPresence'
    }

    def __init__(self, asset_presence=None):
        self._asset_presence = None

        self.asset_presence = asset_presence

    @property
    def asset_presence(self):
        """Gets the asset_presence of this AssetPresence.


        :return: The asset_presence of this AssetPresence.
        :rtype: AssetPresenceStatus
        """
        return self._asset_presence

    @asset_presence.setter
    def asset_presence(self, asset_presence):
        """Sets the asset_presence of this AssetPresence.


        :param asset_presence: The asset_presence of this AssetPresence.
        :type: AssetPresenceStatus
        """
        self._asset_presence = asset_presence

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.property_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AssetPresence):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self.__eq__(other)
