from asset_discovery.plugins.sysapi_imports.repository.models import AttributeTag
from asset_discovery.plugins.sysapi_imports.repository.models.update_property_model import UpdatePropertyModel


class AssetResourceUpdate:
    def __init__(self, resource_uri):
        self._resource_uri = resource_uri
        self._updated_properties = []

    def set_updated_name(self, updated_name):
        if updated_name is not None:
            update = UpdatePropertyModel(tag=AttributeTag.DriverUserAlias0, tag_type="string", updated_value=updated_name)
            self._updated_properties.append(update)

    @property
    def properties(self):
        return self._updated_properties

    @property
    def resource_uri(self):
        return self._resource_uri

    def to_dict(self):
        return {
            "resource_uri": self.resource_uri,
            "properties": [prop.to_dict() for prop in self.properties]
        }
