class PropertyBag:
    def __init__(self, resource_uri, properties=None):
        if properties is None:
            properties = {}
        self._resource_uri = resource_uri
        self._properties = properties

    def get_property_or_default(self, tag, default=None):
        return self._properties.get(tag, default)

    def contains_property(self, tag):
        return tag in self._properties

    def add_property(self, tag, value):
        if type(value) is list:
            for i, val in enumerate(value):
                self._properties[tag+i] = val
        else:
            self._properties[tag] = value

    def is_empty(self):
        return len(self._properties) == 0

    @property
    def resource_uri(self):
        return self._resource_uri

    @property
    def properties(self):
        return self._properties
