import abc


class EntrySerializer(abc.ABC):
    """
    Interface that provides methods to transform a model into its JSON representation.
    Should be used to let the data providers know how to handle resources meant to be stored.
    """

    @abc.abstractmethod
    def to_json(self, entry):
        raise NotImplementedError

    @abc.abstractmethod
    def from_json(self, entry):
        raise NotImplementedError
